/*
 * Skeleton-code behorende bij het college Netwerken, opleiding Informatica,
 * Universiteit Leiden.
 */

#ifndef __COMMON_H__
#define __COMMON_H__

#include "variables.h"
#include "packetbuffer.h"

#include <netinet/in.h>
#include <arpa/inet.h>

#include <stdbool.h>
#include <assert.h>

typedef void (* MainLoopFunc) (void);

/* Thread-safe packet buffers shared among threads. */
extern struct packet_buffer_t incoming_buffer;
extern struct packet_buffer_t outgoing_buffer;

/* Functions */
bool frame_damaged(const float damaged_perc);
bool packet_drop(const float drop_perc);

void *recv_thread_func(void *ptr);
void *send_thread_func(void *ptr);

void msleep(long msec);

int open_send_socket(in_addr_t peer_addr, int send_port);
int open_recv_socket(in_addr_t peer_addr, int recv_port);

bool check_arguments(char **argv, int *port1, in_addr_t *peer_addr, int *port2);

void run(int incoming_port, in_addr_t outgoing_addr, int outgoing_port,
         MainLoopFunc main_loop);

#endif /* __COMMON_H__ */
